/* --------------------------------------------------------
  Generated by Gunandi using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Gunandi (andri.gunandi1@gmail.com) 
 Date Created : 22/05/2019
 --------------------------------------------------------
*/
package com.portofolio.service;

import java.util.ArrayList;
import  java.util.HashMap;
import java.util.List;
import  java.util.Map;

import org.springframework.beans.BeanUtils;
import  org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.context.annotation.Lazy;
import  org.springframework.stereotype.Service;
import  org.springframework.transaction.annotation.Transactional;

import com.portofolio.base.BaseServiceImpl;
import com.portofolio.dao.MapModulAplikasiToObjekModulDao;
import com.portofolio.dao.ObjekModulAplikasiDao;
import com.portofolio.dto.DataMapModulAplikasiToObjekModulDto;
import com.portofolio.dto.MapModulAplikasiToObjekModulDto;
import com.portofolio.entity.MapModulAplikasiToObjekModul;
import com.portofolio.entity.vo.MapModulAplikasiToObjekModulId;
import com.portofolio.util.CommonUtil;




@Service("mapModulAplikasiToObjekModulService")
public class MapModulAplikasiToObjekModulService extends BaseServiceImpl {
    
    @Lazy
    @Autowired
    private MapModulAplikasiToObjekModulDao mapModulAplikasiToObjekModulDao;
    
    @Lazy
    @Autowired
    private ObjekModulAplikasiDao objekModulAplikasiDao;
    
	    
    @Transactional
    public Map<String, Object> saveOrUpdate(DataMapModulAplikasiToObjekModulDto mapmodulaplikasitoobjekmodulDto) {
    	result.clear();
    	try {
    		List<Map<String, Object>> restults = CommonUtil.createList();
    		for (MapModulAplikasiToObjekModulDto dto : mapmodulaplikasitoobjekmodulDto.getMapModulAplikasiToObjekModulDto()) {
    			Map<String, Object> dt = CommonUtil.createMap();
    			MapModulAplikasiToObjekModulId id = new MapModulAplikasiToObjekModulId();
    			id.setKdObjekModulAplikasi(dto.getKdObjekModulAplikasi());
    			id.setKdModulAplikasi(dto.getKdModulAplikasi());
    			id.setKdVersion(dto.getKdVersion());
    			MapModulAplikasiToObjekModul mapModulAplikasiToObjekModul =CommonUtil.findOne(mapModulAplikasiToObjekModulDao, id);
    			if (CommonUtil.isNotNullOrEmpty(mapModulAplikasiToObjekModul)) {
    				BeanUtils.copyProperties(dto, mapModulAplikasiToObjekModul);
    				mapModulAplikasiToObjekModulDao.save(mapModulAplikasiToObjekModul);
    				dt.put("mapModulAplikasikasiToObjekModul", mapModulAplikasiToObjekModul.getId());
    				restults.add(dt);
    			} else {
    				// save baru
    				MapModulAplikasiToObjekModul mapModulAplikasiToObjekModul2 = new MapModulAplikasiToObjekModul();
    				BeanUtils.copyProperties(dto, mapModulAplikasiToObjekModul2);
    				mapModulAplikasiToObjekModul2.setNoRec(generateUuid32());
    				mapModulAplikasiToObjekModul2.setVersion(1);
    				mapModulAplikasiToObjekModul2.setId(id);
    				mapModulAplikasiToObjekModulDao.save(mapModulAplikasiToObjekModul2);
    				dt.put("mapModulAplikasikasiToObjekModul", mapModulAplikasiToObjekModul2.getId());
    				restults.add(dt);
    			}
    		}
    		if (restults.size() > 0) {
    			result.put("mapModulAplikasikasiToObjekModul", restults);
    		}else {
    			result.put("mapModulAplikasikasiToObjekModul", null);
    		}
    		resultUpdated();
		} catch (Exception e) {
			resultError(e);
		}
		
		return result;
	}
    
    
    
	
	
	public Map<String, Object> treeObjekModulAplikasi(String kdModulAplikasi, Integer kdVersion, String namaObjekModulAplikasi) {
		result.clear();
		List<Map<String,Object>> listMapModulAplikasiToObjekModul=new ArrayList<Map<String,Object>>();
		List<Map<String,Object>> tmpListModulAplikasiToObjekModulAplikasiByHead=new ArrayList<Map<String,Object>>();
		List<Map<String,Object>> listObjectModulAplikasiByHead=new ArrayList<Map<String,Object>>();
		try {
			listMapModulAplikasiToObjekModul=mapModulAplikasiToObjekModulDao.findMapModulAplikasiToObjekModulByKdModulAplikasiAndKdVersion(kdModulAplikasi,kdVersion);
			listObjectModulAplikasiByHead=mapModulAplikasiToObjekModulDao.findObjekModulAplikasiHeadIsNull();
			
			
			for(Map<String,Object> object:listObjectModulAplikasiByHead) {
				Map<String,Object> matching = listMapModulAplikasiToObjekModul
						.stream()
						.filter(y -> y.get("kdObjekModulAplikasi").equals(object.get("kdObjekModulAplikasi")))
						.filter(y -> y.get("kdVersion").equals(kdVersion))
						.filter(y -> y.get("kdModulAplikasi").equals(kdModulAplikasi))
						.findAny()
						.orElse(null);
				if(CommonUtil.isNotNullOrEmpty(matching)) {
					object.put("statusEnabled", true);
				}else {
					object.put("statusEnabled", false);
				}
				object.put("children", new HashMap<String,Object>());
				tmpListModulAplikasiToObjekModulAplikasiByHead.add(object);
			}
			result.put("objekModulAplikasiChild", treeObjekModulAplikasiGetChild(tmpListModulAplikasiToObjekModulAplikasiByHead, null,kdModulAplikasi,kdVersion,listMapModulAplikasiToObjekModul));
			resultSuccessful();
		} catch (Exception e) {
			resultError(e);
		}
		
		return  result;
		
	}
	
	
	
	public List<Map<String, Object>> treeObjekModulAplikasiGetChild(List<Map<String, Object>> listObjectModulAplikasiByHead,String kdObjekModulAplikasiHead, String kdModulAplikasi, Integer kdVersion, List<Map<String, Object>> listMapModulAplikasiToObjekModul) {
		if(CommonUtil.isNotNullOrEmpty(kdObjekModulAplikasiHead)) {
			listObjectModulAplikasiByHead=mapModulAplikasiToObjekModulDao.findAllListByKdModulAplikasiAndKdVersionAndKdObjekModulAplikasiHead(kdObjekModulAplikasiHead);
		}
		List<Map<String,Object>> tmpListObjectModulAplikasiByHead=new ArrayList<Map<String,Object>>();
		for(Map<String,Object> object:listObjectModulAplikasiByHead) {
			Map<String,Object> matching = listMapModulAplikasiToObjekModul
					.stream()
					.filter(y -> y.get("kdObjekModulAplikasi").equals(object.get("kdObjekModulAplikasi")))
					.filter(y -> y.get("kdVersion").equals(kdVersion))
					.filter(y -> y.get("kdModulAplikasi").equals(kdModulAplikasi))
					.findAny()
					.orElse(null);
			if(CommonUtil.isNotNullOrEmpty(matching)) {
				object.put("statusEnabled", true);
			}else {
				object.put("statusEnabled", false);
			}
			object.put("children",treeObjekModulAplikasiGetChild(null,(String) object.get("kdObjekModulAplikasi"),kdModulAplikasi,kdVersion,listMapModulAplikasiToObjekModul));
			tmpListObjectModulAplikasiByHead.add(object);
		}
		return listObjectModulAplikasiByHead;
		
	}
	
	

}
